//
//  CommotityListBrand.m
//
//  Created by Z  on 16/4/27
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import "CommotityListBrand.h"


NSString *const kCommotityListBrandName = @"name";
NSString *const kCommotityListBrandUuid = @"uuid";
NSString *const kCommotityListBrandCode = @"code";


@interface CommotityListBrand ()

- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict;

@end

@implementation CommotityListBrand

@synthesize name = _name;
@synthesize uuid = _uuid;
@synthesize code = _code;


+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict
{
    return [[self alloc] initWithDictionary:dict];
}

- (instancetype)initWithDictionary:(NSDictionary *)dict
{
    self = [super init];
    
    // This check serves to make sure that a non-NSDictionary object
    // passed into the model class doesn't break the parsing.
    if(self && [dict isKindOfClass:[NSDictionary class]]) {
            self.name = [self objectOrNilForKey:kCommotityListBrandName fromDictionary:dict];
            self.uuid = [self objectOrNilForKey:kCommotityListBrandUuid fromDictionary:dict];
            self.code = [self objectOrNilForKey:kCommotityListBrandCode fromDictionary:dict];

    }
    
    return self;
    
}

- (NSDictionary *)dictionaryRepresentation
{
    NSMutableDictionary *mutableDict = [NSMutableDictionary dictionary];
    [mutableDict setValue:self.name forKey:kCommotityListBrandName];
    [mutableDict setValue:self.uuid forKey:kCommotityListBrandUuid];
    [mutableDict setValue:self.code forKey:kCommotityListBrandCode];

    return [NSDictionary dictionaryWithDictionary:mutableDict];
}

- (NSString *)description 
{
    return [NSString stringWithFormat:@"%@", [self dictionaryRepresentation]];
}

#pragma mark - Helper Method
- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict
{
    id object = [dict objectForKey:aKey];
    return [object isEqual:[NSNull null]] ? nil : object;
}


#pragma mark - NSCoding Methods

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super init];

    self.name = [aDecoder decodeObjectForKey:kCommotityListBrandName];
    self.uuid = [aDecoder decodeObjectForKey:kCommotityListBrandUuid];
    self.code = [aDecoder decodeObjectForKey:kCommotityListBrandCode];
    return self;
}

- (void)encodeWithCoder:(NSCoder *)aCoder
{

    [aCoder encodeObject:_name forKey:kCommotityListBrandName];
    [aCoder encodeObject:_uuid forKey:kCommotityListBrandUuid];
    [aCoder encodeObject:_code forKey:kCommotityListBrandCode];
}

- (id)copyWithZone:(NSZone *)zone
{
    CommotityListBrand *copy = [[CommotityListBrand alloc] init];
    
    if (copy) {

        copy.name = [self.name copyWithZone:zone];
        copy.uuid = [self.uuid copyWithZone:zone];
        copy.code = [self.code copyWithZone:zone];
    }
    
    return copy;
}


@end
