//
//  MassageViewController.m
//  ALand
//
//  Created by Z on 16/3/18.
//  Copyright © 2016年 Z. All rights reserved.
//

#import "MassageViewController.h"
#import "MessageTableViewCell.h"
#import "UITableView+Category.h"
#import <SobotKit/SobotKit.h>
#import "NavigationbarView.h"

#define kCellID @"cellId"
@interface MassageViewController ()<UITableViewDelegate, UITableViewDataSource>

@property (nonatomic, strong) UITableView *tableView;
@end

@implementation MassageViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.isShowNavigationBar = YES;
    self.title = @"消息";
    self.navigationItem.leftBarButtonItem = nil;
    
    NavigationbarView *navigationBarView = [NavigationbarView viewWithNibName:@"NavigationbarView"];
    navigationBarView.frame = CGRectMake(0, 0, kWidth, 65);
    [self.view addSubview:navigationBarView];
    [self setUpTableView];
    // Do any additional setup after loading the view.
}

- (UIStatusBarStyle)preferredStatusBarStyle {
    return UIStatusBarStyleDefault;
}


- (void)setUpTableView {
    self.tableView = [UITableView plainTableViewWithTarget:self cellNibName:@"MessageTableViewCell" cellId:kCellID];
    self.tableView.frame = CGRectMake(0, 65, kWidth, kHeight);
    [self.view addSubview:self.tableView];
}


- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 95;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 1;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [self startCustomerServices];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    MessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:kCellID forIndexPath:indexPath];
    return cell;
}

- (void)startCustomerServices {
    //企业编号，必填
    
    UserInfo *resellerInfo = [UserInfo shareInstance];
    
    NSString *sysNumber=@"1e5947ae875f4a11af054f153c9422ee";
    
    //启动
    
    ZCLibInitInfo *initInfo = [ZCLibInitInfo new];
    
    initInfo.enterpriseId = sysNumber;
    
    //用户id，用于标识用户，建议填写
    
    initInfo.userId=resellerInfo.uuid;
    
    initInfo.phone=resellerInfo.mobilephone;
    
    initInfo.nickName=resellerInfo.name;
    
    initInfo.email=@"unkown";
    
    ZCKitInfo *uiInfo=[ZCKitInfo new];
    
    uiInfo.info=initInfo;
    
    [self customerUI:uiInfo];
    
    [ZCSobot startZCChatView:uiInfo with:self
     
                   pageBlock:^(ZCUIChatController *object, ZCPageBlockType type) {
                       
                       //点击返回
                       
                       if(type==ZCPageBlockGoBack){
                           
                           NSLog(@"点击了关闭按钮");
                           
                       }
                       
                       //页面UI初始化完成，可以获取UIView，自定义UI
                       
                       if(type==ZCPageBlockLoadFinish){
//                           object.topView.backgroundColor = kSysWhite;
//                           
//                           object.titleLabel.textColor = [UIColor colorWithHexString:@"333333"];
//                           
//                           //banner 返回按钮
//                           object.backButton.tintColor = [UIColor colorWithHexString:@"333333"];
//                           [object.backButton setTitle:@"返回" forState:UIControlStateNormal];
//                           [object.backButton setTitleColor:[UIColor colorWithHexString:@"333333"] forState:UIControlStateNormal];
                           [object.backButton setImage:[UIImage imageNamed:@"bac"] forState:UIControlStateNormal];
//                           object.backButton.titleLabel.font = [UIFont systemFontOfSize:18];
                           //banner 标题
                           
                           //[object.titleLabel setFont:[UIFont systemFontOfSize:30]];
                           
                           //banner 底部View
                           
                           //[object.topView setBackgroundColor:[UIColor greenColor]];
                           
                           //输入框
                           
                           //UITextView *tv=[object getChatTextView];
                           
                           //[tv setBackgroundColor:[UIColor redColor]];
                           
                       }
                       
                       //messageLinkClick ,不重写，系统自己跳转，sdk内部不做任何处理
                       
                   } messageLinkClick:nil];
}


-(void) customerUI:(ZCKitInfo *) kitInfo{
    /**
     
     * 自定义信息
     
     */
    
    //顶部导航条标题文字 评价标题文字 系统相册标题文字 评价客服（立即结束 取消）按钮文字
    
//    kitInfo.titleFont = [UIFont systemFontOfSize:30];
    
    //返回按钮 输入框文字 评价客服是否有以下情况 label 文字 提价评价按钮
    
//    kitInfo.listTitleFont = [UIFont systemFontOfSize:22];
    
    //没有网络提醒的button 没有更多记录label的文字 语音输入的按钮文字 评价不满意（4个button）文字
    
    //占位图片的lablel文字 语音输入时间label文字 语音tipLabel的文字 voiceButton标题文字
    
//    kitInfo.listDetailFont = [UIFont systemFontOfSize:25];
    
    //消息提醒 （转人工、客服接待等）
    
//    kitInfo.listTimeFont = [UIFont systemFontOfSize:22];
    
    //聊天气泡中的文字
    
//    kitInfo.chatFont = [UIFont systemFontOfSize:22];
    
    //聊天的背景颜色
    
//    kitInfo.backgroundColor = [UIColor redColor];
    
    //导航、客服气泡、线条的颜色
    
    kitInfo.customBannerColor = kSysWhite;
    
    //左边气泡的颜色
    
//    kitInfo.leftChatColor = kCustomGreenColor;
    
    //右边气泡的颜色
    
    kitInfo.rightChatColor = kCustomGreenColor;
    
    //底部bottom的背景颜色
    
    kitInfo.backgroundBottomColor = kSysWhite;
    
    //底部bottom的输入框线条背景颜色
    
    //kitInfo.backgroundBottomLineColor = [UIColor redColor];
    
    //提示气泡的背景颜色
    
//    kitInfo.BgTipAirBubblesColor = [UIColor redColor];
    
    //顶部文字的颜色
    
    kitInfo.topViewTextColor = kTextColorDarkGray;
    
    //提示气泡文字颜色
    
    kitInfo.tipLayerTextColor = kTextColorDarkGray;
    
    //左边气泡文字的颜色
    
    kitInfo.leftChatTextColor = kTextColorDarkGray;
    
    //右边气泡文字的颜色[注意：语音动画图片，需要单独替换]
    
//    kitInfo.rightChatTextColor = [UIColor redColor];
    
    //时间文字的颜色
    
//    kitInfo.timeTextColor = [UIColor redColor];
    
    //客服昵称颜色
    
//    kitInfo.serviceNameTextColor = [UIColor redColor];
    
}


- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
