//
//  JavenBrand.m
//
//  Created by Z  on 16/5/9
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import "JavenBrand.h"


NSString *const kJavenBrandName = @"name";
NSString *const kJavenBrandUuid = @"uuid";
NSString *const kJavenBrandCode = @"code";


@interface JavenBrand ()

- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict;

@end

@implementation JavenBrand

@synthesize name = _name;
@synthesize uuid = _uuid;
@synthesize code = _code;


+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict
{
    return [[self alloc] initWithDictionary:dict];
}

- (instancetype)initWithDictionary:(NSDictionary *)dict
{
    self = [super init];
    
    // This check serves to make sure that a non-NSDictionary object
    // passed into the model class doesn't break the parsing.
    if(self && [dict isKindOfClass:[NSDictionary class]]) {
            self.name = [self objectOrNilForKey:kJavenBrandName fromDictionary:dict];
            self.uuid = [self objectOrNilForKey:kJavenBrandUuid fromDictionary:dict];
            self.code = [self objectOrNilForKey:kJavenBrandCode fromDictionary:dict];

    }
    
    return self;
    
}

- (NSDictionary *)dictionaryRepresentation
{
    NSMutableDictionary *mutableDict = [NSMutableDictionary dictionary];
    [mutableDict setValue:self.name forKey:kJavenBrandName];
    [mutableDict setValue:self.uuid forKey:kJavenBrandUuid];
    [mutableDict setValue:self.code forKey:kJavenBrandCode];

    return [NSDictionary dictionaryWithDictionary:mutableDict];
}

- (NSString *)description 
{
    return [NSString stringWithFormat:@"%@", [self dictionaryRepresentation]];
}

#pragma mark - Helper Method
- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict
{
    id object = [dict objectForKey:aKey];
    return [object isEqual:[NSNull null]] ? nil : object;
}


#pragma mark - NSCoding Methods

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super init];

    self.name = [aDecoder decodeObjectForKey:kJavenBrandName];
    self.uuid = [aDecoder decodeObjectForKey:kJavenBrandUuid];
    self.code = [aDecoder decodeObjectForKey:kJavenBrandCode];
    return self;
}

- (void)encodeWithCoder:(NSCoder *)aCoder
{

    [aCoder encodeObject:_name forKey:kJavenBrandName];
    [aCoder encodeObject:_uuid forKey:kJavenBrandUuid];
    [aCoder encodeObject:_code forKey:kJavenBrandCode];
}

- (id)copyWithZone:(NSZone *)zone
{
    JavenBrand *copy = [[JavenBrand alloc] init];
    
    if (copy) {

        copy.name = [self.name copyWithZone:zone];
        copy.uuid = [self.uuid copyWithZone:zone];
        copy.code = [self.code copyWithZone:zone];
    }
    
    return copy;
}


@end
