//
//  JavenOwnerOrg.m
//
//  Created by Z  on 16/5/3
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import "JavenOwnerOrg.h"


NSString *const kJavenOwnerOrgName = @"name";
NSString *const kJavenOwnerOrgUuid = @"uuid";
NSString *const kJavenOwnerOrgCode = @"code";


@interface JavenOwnerOrg ()

- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict;

@end

@implementation JavenOwnerOrg

@synthesize name = _name;
@synthesize uuid = _uuid;
@synthesize code = _code;


+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict
{
    return [[self alloc] initWithDictionary:dict];
}

- (instancetype)initWithDictionary:(NSDictionary *)dict
{
    self = [super init];
    
    // This check serves to make sure that a non-NSDictionary object
    // passed into the model class doesn't break the parsing.
    if(self && [dict isKindOfClass:[NSDictionary class]]) {
            self.name = [self objectOrNilForKey:kJavenOwnerOrgName fromDictionary:dict];
            self.uuid = [self objectOrNilForKey:kJavenOwnerOrgUuid fromDictionary:dict];
            self.code = [self objectOrNilForKey:kJavenOwnerOrgCode fromDictionary:dict];

    }
    
    return self;
    
}

- (NSDictionary *)dictionaryRepresentation
{
    NSMutableDictionary *mutableDict = [NSMutableDictionary dictionary];
    [mutableDict setValue:self.name forKey:kJavenOwnerOrgName];
    [mutableDict setValue:self.uuid forKey:kJavenOwnerOrgUuid];
    [mutableDict setValue:self.code forKey:kJavenOwnerOrgCode];

    return [NSDictionary dictionaryWithDictionary:mutableDict];
}

- (NSString *)description 
{
    return [NSString stringWithFormat:@"%@", [self dictionaryRepresentation]];
}

#pragma mark - Helper Method
- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict
{
    id object = [dict objectForKey:aKey];
    return [object isEqual:[NSNull null]] ? nil : object;
}


#pragma mark - NSCoding Methods

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super init];

    self.name = [aDecoder decodeObjectForKey:kJavenOwnerOrgName];
    self.uuid = [aDecoder decodeObjectForKey:kJavenOwnerOrgUuid];
    self.code = [aDecoder decodeObjectForKey:kJavenOwnerOrgCode];
    return self;
}

- (void)encodeWithCoder:(NSCoder *)aCoder
{

    [aCoder encodeObject:_name forKey:kJavenOwnerOrgName];
    [aCoder encodeObject:_uuid forKey:kJavenOwnerOrgUuid];
    [aCoder encodeObject:_code forKey:kJavenOwnerOrgCode];
}

- (id)copyWithZone:(NSZone *)zone
{
    JavenOwnerOrg *copy = [[JavenOwnerOrg alloc] init];
    
    if (copy) {

        copy.name = [self.name copyWithZone:zone];
        copy.uuid = [self.uuid copyWithZone:zone];
        copy.code = [self.code copyWithZone:zone];
    }
    
    return copy;
}


@end
