//
//  UserInfoCreateInfo.m
//
//  Created by Z  on 16/5/11
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import "UserInfoCreateInfo.h"
#import "UserInfoOperator.h"


NSString *const kUserInfoCreateInfoOperator = @"operator";
NSString *const kUserInfoCreateInfoTime = @"time";


@interface UserInfoCreateInfo ()

- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict;

@end

@implementation UserInfoCreateInfo

@synthesize operator = _operator;
@synthesize time = _time;


+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict
{
    return [[self alloc] initWithDictionary:dict];
}

- (instancetype)initWithDictionary:(NSDictionary *)dict
{
    self = [super init];
    
    // This check serves to make sure that a non-NSDictionary object
    // passed into the model class doesn't break the parsing.
    if(self && [dict isKindOfClass:[NSDictionary class]]) {
            self.operator = [UserInfoOperator modelObjectWithDictionary:[dict objectForKey:kUserInfoCreateInfoOperator]];
            self.time = [[self objectOrNilForKey:kUserInfoCreateInfoTime fromDictionary:dict] doubleValue];

    }
    
    return self;
    
}

- (NSDictionary *)dictionaryRepresentation
{
    NSMutableDictionary *mutableDict = [NSMutableDictionary dictionary];
    [mutableDict setValue:[self.operator dictionaryRepresentation] forKey:kUserInfoCreateInfoOperator];
    [mutableDict setValue:[NSNumber numberWithDouble:self.time] forKey:kUserInfoCreateInfoTime];

    return [NSDictionary dictionaryWithDictionary:mutableDict];
}

- (NSString *)description 
{
    return [NSString stringWithFormat:@"%@", [self dictionaryRepresentation]];
}

#pragma mark - Helper Method
- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict
{
    id object = [dict objectForKey:aKey];
    return [object isEqual:[NSNull null]] ? nil : object;
}


#pragma mark - NSCoding Methods

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super init];

    self.operator = [aDecoder decodeObjectForKey:kUserInfoCreateInfoOperator];
    self.time = [aDecoder decodeDoubleForKey:kUserInfoCreateInfoTime];
    return self;
}

- (void)encodeWithCoder:(NSCoder *)aCoder
{

    [aCoder encodeObject:_operator forKey:kUserInfoCreateInfoOperator];
    [aCoder encodeDouble:_time forKey:kUserInfoCreateInfoTime];
}

- (id)copyWithZone:(NSZone *)zone
{
    UserInfoCreateInfo *copy = [[UserInfoCreateInfo alloc] init];
    
    if (copy) {

        copy.operator = [self.operator copyWithZone:zone];
        copy.time = self.time;
    }
    
    return copy;
}


@end
